; XMOSlisp is a tiny lisp interpreter for XMOS devices.
; Copyright (C) 2010		Ruben Vandamme
;
; This program is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program.  If not, see <http://www.gnu.org/licenses/>.



;Timer example
(pout clockled0 15) (pout clockled1 15) (pout clockled2 15) (pout clockselr 1) (after (+ (timer) 200000000)) (pout clockselr 0)

(pout clockled0 (pout clockled1 (pout clockled2 (pout clockselr 15)))) (pout clockselr(after (+ (timer) 200000000) 0))

;Fast way to put all leds on
(pout clockled0 (pout clockled1 (pout clockled2 15)))

;Function led example
(define clock (lambda (x)(pout clockled0 (pout clockled1 (pout clockled2 x)))))
(clock 1) (clock 2) (clock 4) (clock 8)
(clock (* 2 (clock (* 2 (clock (* 2 (clock 1)))))))

;Pin (not) equal
(pout buttonled (* 16 (pout clockled0 (pout clockled1 (pout clockled2 (pne button 15))))))

;Led button
((lambda x (apply (car x) x))
 (lambda (f n) (f f (pout clockled2 (pne button n)))) 15)

((lambda x (apply (car x) x))
 (lambda (f) (f (pout clockled2 (pne button 15)))))

;Delayed led button
((lambda x (apply (car x) x))
 (lambda (f n) (f f (after (+ (timer) 100000000) (pout clockled2 (pne button n))))) 15)

;Delayed led button two
((lambda x (apply (car x) x))
 (lambda (f n) (f f (pout clockled2 (after (+ (timer) 100000000) (pne button n))))) 15)

;Led carrousel
((lambda x (apply (car x) x))
 (lambda (f n)
  (f f
   (after (+ (timer) 20000000)
    (% (* 2 (pout clockled0 (pout clockled1 (pout clockled2 n)))) 15)
 )))
 1
)
